<?php

/**
 * @version     $Id: view.html.php 9 2014-09-29 10:51:55Z david.dorchies $
 * @package     Joomla16.Tutorials
 * @subpackage  Components
 * @copyright   Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @author      Christophe Demko
 * @link        http://joomlacode.org/gf/project/umrmanagement_1_6/
 * @license     License GNU General Public License version 2 or later
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla view library
jimport('joomla.application.component.view');

// Import parent's class of UmrManagementViewExport
require_once(JPATH_COMPONENT.DS.'views'.DS.'export'.DS.'view.parent.php');

/**
 * UmrManagements View
 */
class UmrManagementViewExport extends UmrManagementViewExportParent
{
    /**
     * UmrManagements view display method
     * @return void
     */
    function display($tpl = null)
    {
        // Load Items and parameters...
        $this->getData();

        // Get data from the model
        $this->form = $this->get('Form');
        $this->pagination = $this->get('Pagination');

        // Include the component HTML helpers.
        JHtml::addIncludePath(JPATH_COMPONENT . '/helpers/html');

        // Set the toolbar
        $this->addToolBar();

        // Display the template
        parent::display($tpl);

        // Set the document
        $document = JFactory::getDocument();
        $document->setTitle(JText::_('COM_UMRMANAGEMENT').' - '.JText::_('COM_UMRMANAGEMENT_EXPORT_TITLE'));
    }

    /**
     * Setting the toolbar
     */
    protected function addToolBar()
    {
        JToolBarHelper::title(JText::_('COM_UMRMANAGEMENT_EXPORT_TITLE'));
        JToolBarHelper::apply('', 'COM_UMRMANAGEMENT_EXPORT_BUTTON');
    }
}
