<?php

/**
 * @version     $Id: umrtools.php 9 2014-09-29 10:51:55Z david.dorchies $
 * @package     Joomla16.Tutorials
 * @subpackage  Components
 * @copyright   Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @author      Christophe Demko
 * @link        http://joomlacode.org/gf/project/umrmanagement_1_6/
 * @license     License GNU General Public License version 2 or later
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import the Joomla modellist library
jimport('joomla.application.component.model');
/**
 * UmrTools Model : miscelaneous tools for Umr Management component
 */
class UmrManagementModelUmrTools extends JModel
{
    /**
     * Affiche le libellé d'un champ à partir de la table umrmanagement_libelle
     * @author David Dorchies
     * @date 11/05/2014
     */
    static public function getLibelleMain($champ,$id=0,$cat=0)
    {
        if(is_numeric($id) && is_numeric($cat)) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select($db->quotename(array('libelle_court','libelle_long')));
            $query->from($db->quotename('#__umrmanagement_libelle','l'));
            $query->where($db->quotename('variable').' LIKE '.$db->quote($champ));
            $query->where($db->quotename('id').' = '.$id);
            $query->where($db->quotename('categorie').' = '.$cat);
            $db->setQuery($query);
            $result = $db->loadRow();
        } else {
            $result = array('libelle_court'=>'NULL','libelle_long'=>'Non saisi');
        }
        return $result;
    }


    static public function getLibelleCourt($champ,$id,$cat=0)
    {
        $tLib = self::getLibelleMain($champ,$id,$cat=0);
        return $tLib[0];
    }


    static public function getLibelleLong($champ,$id,$cat=0)
    {
        $tLib = self::getLibelleMain($champ,$id,$cat=0);
        return $tLib[1];
    }

    static public function getLibelle($champ,$id,$cat=0)
    {
        $tLib = self::getLibelleMain($champ,$id,$cat);
        $s = $tLib[0];
        if($tLib[0]!='' && $tLib[0]!='') {$s .= ' - ';}
        $s .= $tLib[1];
        return $s;
    }


    static public function getMemberName()
    {
        $mainframe = JFactory::getApplication();
        // retrieve the value of the state variable. First see if the variable has been passed
        // in the request. Otherwise retrieve the stored value. If none of these are specified,
        // the specified default value will be returned
        // function syntax is getUserStateFromRequest( $key, $request, $default );
        $id = $mainframe->getUserStateFromRequest( 'com_umrmanagement.attendances.id_membre', 'id');

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select($db->quotename('name'));
        $query->from($db->quotename('#__umrmanagement'));
        $query->where($db->quotename('id').' = '.$id);
        $db->setQuery($query);
        $result = $db->loadResult();
        return $result;
    }


    /**
     * Récupération de la liste des champs pour les informations complémentaires
     * @param $categorie Identifiant de la catégorie pour laquelle récupérer les champs
     * @return Array avec la liste des noms de champs
     */
     static public function getChampsExtraInfo($categorie) {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select($db->quotename('nom_champ'));
        $query->from($db->quotename('#__umrmanagement_selectlib'));
        if($categorie) {
            // sinon, tous les personnels => tous les champs complémentaires
            $query->where($db->quotename('idcat').' = '.$categorie);
        }
        $query->order('ordre_champ');
        $db->setQuery($query);
        return array_unique($db->loadColumn());
    }


    /**
     * Récupération de la valeur des champs des informations complémentaires pour un mouvement
     * @param $idmvt Identifiant du mouvement
     * @return Array de la liste de champ contenant un array('nom'=>...,'valeur'=>...) pour chaque champ
     */
     static public function getChampsExtraItem($idmvt) {
        $aExtraInfos2 = array();
        if(is_numeric($idmvt)) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select($db->quotename(array('nom','valeur')));
            $query->from($db->quotename('#__umrmanagement_enregistrements'));
            $query->where($db->quotename('idmvt')." = $idmvt");
            $db->setQuery($query);
            $aExtraInfos = $db->loadAssocList();
            foreach($aExtraInfos as &$aExtraInfo) {
                $aExtraInfos2[$aExtraInfo['nom']] = $aExtraInfo['valeur'];
            }
        }
        return $aExtraInfos2;
    }


    /**
     * Récupération des paramètres d'un champ des informations complémentaires
     * @param $sChamp Nom du champ
     * @return Array des paramètres : type et libelle du champ
     */
     static public function getChampsExtraParam($sChamp) {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select($db->quotename(array('type','libelle')));
        $query->from($db->quotename('#__umrmanagement_structurelib'));
        $query->where($db->quotename('nom').' = '.$db->quote($sChamp));
        $db->setQuery($query);
        return $db->loadAssoc();
    }
}
